/*
 * image_utils.h
 *
 *  Created on: 2 cze 2018
 *      Author: mzaleczny
 */

#ifndef SRC_IMAGE_UTILS_H_
#define SRC_IMAGE_UTILS_H_

#include "SDL2/SDL.h"
#include "SDL2/SDL_image.h"

#pragma pack(push, 1)
typedef struct _tga_head {
    unsigned char  id_length;
    unsigned char  color_map_type;
    unsigned char  image_type;
    unsigned short color_map_offset;
    unsigned short color_map_length;
    unsigned char  color_map_size;
    unsigned short image_x_origin;
    unsigned short image_y_origin;
    unsigned short image_width;
    unsigned short image_height;
    unsigned char  image_depth;
    unsigned char  image_descriptor;
} t_tga_head;
#pragma pack(pop)

void *read_tga(const char *filename, int *width, int *height, int *depth);
int invert_surface_vertical(SDL_Surface *surface);

#endif /* SRC_IMAGE_UTILS_H_ */
