/*
 * memory_utils.h
 *
 *  Created on: 20 maj 2018
 *      Author: mzaleczny
 */

#ifndef SRC_MEMORY_UTILS_H_
#define SRC_MEMORY_UTILS_H_

#include <stdlib.h>


typedef struct _mem_buffer {
    // buffer for array of items
    void *buffer;
    // size of single item
    size_t item_size;
    // available items in buffer
    size_t items_count;
    // all items reserved for buffer - not all are currently assigned (contain valid data)
    size_t available_items_count;
} t_mem_buffer;


// Dodaje nową pozycję w buforze i zwraca jej indeks. Jeśli rozmiar bufora nie pozwala dodać nowej pozycji,
// to jest on realokowany o rozmiarze 2 * większym i wtedy pozycja jest dodawana.
// Funkcja zwraca indeks nowo dodanej pozycji.
int add_uninitialised_item_to_buffer(t_mem_buffer *buffer);


#endif /* SRC_MEMORY_UTILS_H_ */
