#ifndef __PHYSICS_H__
#define __PHYSICS_H__

#include "mathext.h"



/* masa punktowa */
typedef struct _point_mass {
    float mass;  /* masa */
    vector3 design_position;  /* położenie w zewnętrznym układzie współrzędnych */
    vector3 corrected_position;  /* położenie w układzie środka ciężkości, czyli
                                    w układzie którego środkiem jest środek ciężkości */
    vector3 local_inertia;    /* lokalny moment bezwładności elementu składowego */
} point_mass;


void init_point_mass(point_mass *pm);
/* cg - center of gravity - środek ciężkości */
void calculate_point_mass_params(point_mass *pm, int pm_count, float *total_mass, vector3 *cg);
void calculate_inertia_tensor(float inertia_tensor[9], point_mass *pm, int pm_count);

#endif
