/*
 * platform2d.h
 *
 *  Created on: 27 sty 2018
 *      Author: mzaleczny
 */

#ifndef SRC_PLATFORM2D_H_
#define SRC_PLATFORM2D_H_

#include "texture.h"

#define PLATFORM2D_TILE_TYPE(platform2d,x,y) platform2d->tiles[(y)*(platform2d)->map_size_in_tiles_width+(x)]

typedef struct _tile_types_properties {
    float x;                    // położenie x obrazka tile'a we współrzędnych tekstury
    float y;                    // położenie y obrazka tile'a we współrzędnych tekstury
    float w;                    // szerokość obrazka tile'a we współrzędnych tekstury
    float h;                    // wysokość obrazka tile'a we współrzędnych tekstury
    unsigned long pos_x;                // pozycja x obrazka tile'a w pliku obrazka tekstury
    unsigned long pos_y;                // pozycja y obrazka tile'a w pliku obrazka tekstury
    unsigned long size_w;               // szerokość obrazka tile'a w pliku obrazka tekstury
    unsigned long size_h;               // wysokość obrazka tile'a w pliku obrazka tekstury
    float tile_w;             // szerokość tile'a na ekranie
    float tile_h;             // wysokość tile'a na ekranie
} t_tile_types_properties;


typedef unsigned int platform2d_tile_type;
typedef struct _platform2d {
    // ilość różnych tilesów mapy platformy 2d
    unsigned int tile_types_count;
    // frame_sizes zawiera tile_types_count struktur t_tile_state_frame_sizes
    t_tile_types_properties *tile_types_properties;
    t_texturemap *texturemap; // mapa tekstur zawierająca tilesy,które będziemy rysować
                              // powinna być utworzona/wczytana przed utworzeniem obiektu t_platform2d
                              // nie jest ona zwalniana w destruktorze free_platform2d

    float level_size_in_reals_width;
    float level_size_in_reals_height;

    unsigned int map_size_in_tiles_width;
    unsigned int map_size_in_tiles_height;
    platform2d_tile_type *tiles;

    // wymiary mapy we współrzędnych świata opengl
    float map_width;
    float map_height;

    // poniższe dwie zmienne służą do kontroli przewijania mapy
    float translate_x;
    float translate_y;
} t_platform2d;


t_platform2d *load_platform2d_from_file(char *filename, t_texturemap *texturemap);
void free_platform2d(t_platform2d *platform);
void render_platform(t_platform2d *platform);

#endif /* SRC_PLATFORM2D_H_ */
